/*
 * Network disk client
 * Debugging support
 *
 * Copyright (c) 1996 Petr Salinger
 * Copyright (c) 1999 Libor Bus <l.bus@sh.cvut.cz>
 * Copyright (c) 2001 Lubomir Bulej <pallas@kadan.cz>
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef _NWD_DEBUG_H
#define _NWD_DEBUG_H

#include <linux/kernel.h>

#if 0
#define dprintk(args...)	printk (KERN_DEBUG "nwd: " args)
#define denterfn(args...)	printk (KERN_DEBUG "nwd: enter " __FUNCTION__ args)
#define	dleavefn(args...)	printk (KERN_DEBUG "nwd: leave " __FUNCTION__ args)
#else
#define dprintk(args...)
#define denterfn(args...)
#define dleavefn(args...)
#endif

#define iprintk(args...)	printk (KERN_INFO "nwd: " args)
#define eprintk(args...)	printk (KERN_ERR "nwd: error: " args)
#define wprintk(args...)	printk (KERN_WARNING "nwd: warning: " args)

#endif /* _NWD_DEBUG_H */
