#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/sysctl.h>
#include <linux/grinternal.h>

#ifdef CONFIG_GRKERNSEC_MODSTOP
int grsec_modstop;
#endif

int
gr_handle_sysctl_mod(const char *dirname, const char *name, const int op)
{
#ifdef CONFIG_GRKERNSEC_SYSCTL
	if (!strcmp(dirname, "grsecurity") && grsec_lock && (op & 002)) {
		gr_log_str(GR_DONT_AUDIT, GR_SYSCTL_MSG, name);
		return -EACCES;
	}
#endif
#ifdef CONFIG_GRKERNSEC_MODSTOP
	if (!strcmp(dirname, "grsecurity") && !strcmp(name, "disable_modules") &&
	    grsec_modstop && (op & 002)) {
		gr_log_str(GR_DONT_AUDIT, GR_SYSCTL_MSG, name);
		return -EACCES;
	}
#endif
		
	return 0;
}

int gr_check_modstop(void)
{
#ifdef CONFIG_GRKERNSEC_MODSTOP
	if (grsec_modstop != 0) {
		gr_log_noargs(GR_DONT_AUDIT, GR_STOPMOD_MSG);
		return 1;
	}
#endif
	return 0;
}	
